//
//  RootViewController.m
//  test
//
//  Created by kunii on 10/03/22.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "RootViewController.h"


@implementation RootViewController

- (void)viewDidLoad {
    [super viewDidLoad];

	CGRect r = self.tableView.bounds;
	r.origin.y -= 40;
	r.size.height = 40;
	triggerHeader = [[UILabel alloc] initWithFrame:r]; 
	triggerHeader.text = @"更新";
	[self.tableView addSubview:triggerHeader];

	//	トリガーのイメージを埋め込むtriggerHeader
	UIImageView* imageview = [[UIImageView alloc] initWithFrame:CGRectMake(100, (40 - 16) / 2, 16, 16)];
	imageview.image = [UIImage imageNamed:@"arrow.png"];
	imageview.tag = 1;
	[triggerHeader addSubview:imageview];
	[imageview release];
	headerOn = NO;
	
	//	末尾
	r = self.tableView.bounds;
	r.origin.y = 0;
	r.size.height = 40;
	triggerFooter = [[UILabel alloc] initWithFrame:r]; 
	triggerFooter.text = @"更新";
	self.tableView.tableFooterView = triggerFooter;
	imageview = [[UIImageView alloc] initWithFrame:CGRectMake(100, (40 - 16) / 2, 16, 16)];
	imageview.image = [UIImage imageNamed:@"arrow.png"];
	imageview.tag = 1;
	[triggerFooter addSubview:imageview];
	[imageview release];

	footerOn = NO;

	[triggerHeader release];
	[triggerFooter release];
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {               // any offset changes
	//	ヘッダー側
	CGRect r = self.tableView.bounds;
	triggerHeader.text = [NSString stringWithFormat:@"%lf", r.origin.y];
	if ((r.origin.y < -50) && (headerOn == NO)) {
		headerOn = YES;
		UIImageView* imageview = (UIImageView*)[triggerHeader viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformRotate(CGAffineTransformIdentity, 3.14);
		[UIView commitAnimations];
	}
	if ((r.origin.y > -50) && (headerOn == YES)) {
		headerOn = NO;
		UIImageView* imageview = (UIImageView*)[triggerHeader viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformIdentity;
		[UIView commitAnimations];
	}
	//	フッター側
	double tableTail = r.origin.y + r.size.height;
	double triggerTail = triggerFooter.frame.origin.y + triggerFooter.frame.size.height;
	triggerFooter.text = [NSString stringWithFormat:@"%.0lf %.0lf", tableTail, triggerTail];
	if ((tableTail > triggerTail + 20) && (footerOn == NO)) {
		footerOn = YES;
		UIImageView* imageview = (UIImageView*)[triggerFooter viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformRotate(CGAffineTransformIdentity, 3.14);
		[UIView commitAnimations];
	}
	if ((tableTail < triggerTail + 20) && (footerOn == YES)) {
		footerOn = NO;
		UIImageView* imageview = (UIImageView*)[triggerFooter viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformIdentity;
		[UIView commitAnimations];
	}
	
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 20;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
	cell.textLabel.text = [NSString stringWithFormat:@"項目-%d",indexPath.row];

    return cell;
}



/*
// Override to support row selection in the table view.
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

    // Navigation logic may go here -- for example, create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController animated:YES];
	// [anotherViewController release];
}
*/


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
    [super dealloc];
}


@end

